-- TRIX index indicator
function Init()
    indicator:name("Multi Time Frame Heikin-Ashi");
    indicator:description("");
    indicator:requiredSource(core.Bar);
    indicator:type(core.Indicator);	

    
	
	Parameters (1 , "H1" );
	Parameters (2 , "H4" );
	Parameters (3 , "H8" );
    Parameters (4 , "D1" );
	Parameters (5 , "W1" );
	
	indicator.parameters:addGroup("Common Parameters");	
	indicator.parameters:addInteger("ArrowSize", "ArrowSize", "", 10);
	
	indicator.parameters:addInteger("Position", "Vertical Position", "", 0, 0 , 500);
	 
	 indicator.parameters:addColor("Label", "Label Color", "", core.rgb(0, 0, 0)); 
	indicator.parameters:addColor("Up", "Up Arrow Color", "", core.rgb(0, 255, 0));
	indicator.parameters:addColor("Down", "Down Arrow Color", "", core.rgb(255, 0, 0));
	
end


function Parameters (id , FRAME )  	  
    indicator.parameters:addString("B"..id, "RSI Time frame", "", FRAME);
    indicator.parameters:setFlag("B"..id, core.FLAG_PERIODS);
end

local Label;
local Up, Down;


local  ArrowSize;
local source;
local day_offset, week_offset;
local dummy;
local stream=nil;
local host;
--local alive;
local first;
local font1, font2,font3;
local Position;

local HA;


function ReleaseInstance()
       core.host:execute("deleteFont", font1);
       core.host:execute("deleteFont", font2);
	  
   end

function Prepare()       
    Label=instance.parameters.Label;
	Up=instance.parameters.Up;
    Down=instance.parameters.Down;
    Position=instance.parameters.Position;   
   
    ArrowSize=instance.parameters.ArrowSize;   
	
    local name =  profile:id() .. ","  .. instance.source:name() ;
	
    source = instance.source;
	first= source:first()+1;
    host = core.host;

    day_offset = host:execute("getTradingDayOffset");
    week_offset = host:execute("getTradingWeekOffset");   
	
	
    dummy = instance:addInternalStream(0, 0);
	local i;
	for i= 1, 5, 1 do
	name = name..", ("  .. instance.parameters:getString ("B"..i)  .. ")";      
	end
	instance:name(name);
	
	   font1 = core.host:execute("createFont", "Arial", ArrowSize, true, false);
       font2 = core.host:execute("createFont", "Wingdings", ArrowSize, false, false);
	 
end


function Update(period,mode)

     if not source:hasData(period) or  period < source:size()-1 then 
     return;
     end
  
	local i;
	
	
		
	if stream == nil then	
	HA= {}; 
	stream= {};
		for i = 1, 5 , 1 do	 
			stream[i] = registerStream(i, instance.parameters:getString ("B"..i),10);
			HA[i] = core.indicators:create("HA", stream[i]);			
		end
	end		
			
	
	
			for i = 1, 5, 1  do
		  
		    HA[i]:update(mode);
			 
			 if HA[i].open:hasData(HA[i].DATA:size()-1) then
			
			
			 											

							
							 
							      core.host:execute("drawLabel1", i+10, -i*50, core.CR_RIGHT,Position+75, core.CR_TOP, core.H_Right, core.V_Bottom,
                             font1, Label, instance.parameters:getString ("B"..i));
							 
						
											   if HA[i].close[HA[i].DATA:size()-1] > HA[i].open[HA[i].DATA:size()-1] then
																										
														core.host:execute("drawLabel1", i, -i*50, core.CR_RIGHT, Position+ 100, core.CR_TOP, core.H_Right, core.V_Bottom,
														font2, Up, "\241");														
												
												elseif HA[i].close[HA[i].DATA:size()-1] < HA[i].open[HA[i].DATA:size()-1] then
												
														core.host:execute("drawLabel1", i, -i*50,core.CR_RIGHT, Position+ 100, core.CR_TOP, core.H_Right, core.V_Bottom,
														font2, Down, "\242");													 
												
												else
													
                                               core.host:execute("drawLabel1", i, -i*50 ,core.CR_RIGHT,  Position+100, core.CR_TOP, core.H_Right, core.V_Bottom,
                                                font2, core.rgb(0, 0, 255), "\243");												
												
												end 		
									      										
				end
	     end
end


local streams = {}


-- register stream
-- @param barSize       Stream's bar size
-- @param extent        The size of the required exten
-- @return the stream reference
function registerStream(id, barSize, extent)
    local stream = {};
    local s1, e1, length;
    local from, to;

    s1, e1 = core.getcandle(barSize, core.now(), 0, 0);
    length = math.floor((e1 - s1) * 86400 + 0.5);

    -- the size of the source
    if barSize == source:barSize() then
        stream.data = source;
        stream.barSize = barSize;
        stream.external = false;
        stream.length = length;
        stream.loading = false;
        stream.extent = extent;
        stream.loading = false;
    else
        stream.data = nil;
        stream.barSize = barSize;
        stream.external = true;
        stream.length = length;
        stream.loading = false;
        stream.extent = extent;
        local from, dataFrom
        from, dataFrom = getFrom(barSize, length, extent);
        if (source:isAlive()) then
            to = 0;
        else
            t, to = core.getcandle(barSize, source:date(source:size() - 1), day_offset, week_offset);
        end
        stream.loading = true;
        stream.loadingFrom = from;
        stream.dataFrom = dataFrom;
        stream.data = host:execute("getHistory", id, source:instrument(), barSize, from, to, source:isBid());
        setBookmark(0);
    end
    streams[id] = stream;
    return stream.data;
end

function getPeriod(id, period)
    local stream = streams[id];
    assert(stream ~= nil, "Stream is not registered");
    local candle, from, dataFrom, to;
    if stream.external then
        candle = core.getcandle(stream.barSize, source:date(period), day_offset, week_offset);
        if candle < stream.dataFrom then
            setBookmark(period);
            if stream.loading then
                return -1, true;
            end
            from, dataFrom = getFrom(stream.barSize, stream.length, stream.extent);
            stream.loading = true;
            stream.loadingFrom = from;
            stream.dataFrom = dataFrom;
            host:execute("extendHistory", id, stream.data, from, stream.data:date(0));
            return -1, true;
        end

        if (not(source:isAlive()) and candle > stream.data:date(stream.data:size() - 1)) then
            setBookmark(period);
            if stream.loading then
                return -1, true;
            end
            stream.loading = true;
            from = bf_data:date(bf_data:size() - 1);
            to = candle;
            host:execute("extendHistory", id, stream.data, from, to);
        end

        local p;
        p = core.findDate(stream.data, candle, true);
        return p, stream.loading;
    else
        return period;
    end
end

function setBookmark(period)
    local bm;
    bm = dummy:getBookmark(1);
    if bm < 0 then
        bm = period;
    else
        bm = math.min(period, bm);
    end
    dummy:setBookmark(1, bm);

end

-- get the from date for the stream using bar size and extent and taking the non-trading periods
-- into account
function getFrom(barSize, length, extent)
    local from, loadFrom;
    local nontrading, nontradingend;

    from = core.getcandle(barSize, source:date(source:first()), day_offset, week_offset);
    loadFrom = math.floor(from * 86400 - 2 * length * extent + 0.5) / 86400;
    nontrading, nontradingend = core.isnontrading(from, day_offset);
    if nontrading then
        -- if it is non-trading, shift for two days to skip the non-trading periods
        loadFrom = math.floor((loadFrom - 2) * 86400 - 2 * length * extent + 0.5) / 86400;
    end
    return loadFrom, from;
end

-- the function is called when the async operation is finished
function AsyncOperationFinished(cookie)
    local period;
    local stream = streams[cookie];
    if stream == nil then
        return ;
    end
    stream.loading = false;
    period = dummy:getBookmark(1);
    if (period < 0) then
        period = 0;
    end
    loading = false;
    instance:updateFrom(period);
end

